SystemOrganization addCategory: #'Xpf-CodeTalk'!
SystemOrganization addCategory: #'Xpf-CodeTalk-Commands'!
SystemOrganization addCategory: #'Xpf-CodeTalk-Core'!
SystemOrganization addCategory: #'Xpf-CodeTalk-Tests'!
SystemOrganization addCategory: #'Xpf-CodeTalk-Morphs'!
SystemOrganization addCategory: #'Xpf-CodeTalk-Models'!

!OBCmdMultiView methodsFor: '*xpf-codetalk-override' stamp: 'mt 4/28/2009 08:46'!
execute
	|viewType|
	viewType := OBChoiceRequest labels: #(Source Bytecode Decompile PrettyPrint Xpf).
	self styler: SHTextStylerST80 new.
	viewType ifNotNil: [self perform: (#toggle, viewType) asSymbol]! !

!OBCmdMultiView methodsFor: '*xpf-codetalk' stamp: 'cs 1/15/2009 17:24'!
styler: styler
	| panel morph |
	
	panel := requestor browser panels 
		detect: [ :each | each isKindOf: OBDefinitionPanel ]
		ifNone: [ ^ self ].
	morph := OBPluggableTextMorph allSubInstances
		detect: [ :each | each model == panel ]
		ifNone: [ ^ self ].
	morph styler: (styler
		view: morph;
		yourself).! !

!OBCmdMultiView methodsFor: '*xpf-codetalk' stamp: 'topa 2/13/2009 13:47'!
toggleXpf

	self styler: XpfTextStyler new.
	self setTextInDefinitionPanel: target source.! !

OBLazyListMorph subclass: #XpfLazyListMorph
	instanceVariableNames: 'showCategories'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-CodeTalk-Core'!

!XpfLazyListMorph methodsFor: 'as yet unclassified' stamp: 'mt 4/29/2009 21:26'!
display: item  atRow: row on: canvas
	"display the given item at row row"
	| drawBounds top icon |
	drawBounds := self drawBoundsForRow: row.
	drawBounds := drawBounds intersect: self bounds.

	(listSource backgroundColorAt: row) ifNotNilDo: [:aColor | canvas fillRectangle: drawBounds color: aColor].

	(listSource iconAt: row) ifNotNilDo: 
		[:name |
		icon := OBMorphicIcons iconNamed: name.
		top := drawBounds top + (drawBounds height - icon height // 2).
		canvas translucentImage: icon at: drawBounds left @ top.
		drawBounds := drawBounds left: drawBounds left + icon width + 2].
		
	item isText
		ifTrue: [canvas
			drawString: item
			in: drawBounds
			font: (font emphasized: (item emphasisAt: 1))
			color: (self colorForRow: row).
			drawBounds := drawBounds left: drawBounds left + ((font emphasized: (item emphasisAt: 1)) widthOfString: item)]
		ifFalse: [canvas
			drawString: item
			in: drawBounds
			font: font
			color: (self colorForRow: row).
			drawBounds := drawBounds left: drawBounds left + (font widthOfString: item)].
	
	((listSource model children at: row) isKindOf: OBMethodNode) "& (row ~= selectedRow)"
		ifTrue: [self
			displayCategoryFor: (listSource model children at: row)
			in: drawBounds
			on: canvas].! !

!XpfLazyListMorph methodsFor: 'as yet unclassified' stamp: 'mt 4/29/2009 16:06'!
displayCategoryFor: aMethodNode in: drawBounds on: aCanvas

	self updateProperties.
	showCategories ifTrue: [aCanvas
		drawString: aMethodNode categoryText
		in: drawBounds
		font: font
		color: Color gray].! !

!XpfLazyListMorph methodsFor: 'as yet unclassified' stamp: 'mt 4/29/2009 16:05'!
updateProperties

	showCategories ifNil: [showCategories := (Preferences preferenceAt: #showProtocolForMessage ifAbsent: [Preference new rawValue: false]) preferenceValue].! !

!DataStream methodsFor: '*xpf-codetalk' stamp: 'mt 3/24/2009 15:43'!
references

    ^ Dictionary new! !

TestCase subclass: #XpfCtMonticelloTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-CodeTalk-Tests'!

!XpfCtMonticelloTest methodsFor: 'as yet unclassified' stamp: 'cs 4/22/2009 15:54'!
testAddCodeMarkup
	| ref source md snapshotBin md2 color |
	ref := MethodReference class: Collection selector: #do:.
	source := ref sourceCode.
	source addAttribute: (XpfTextBackgroundColor color: Color green) from: 1 to: 1.
	color := ((source attributesAt: 1) detect: [:attr | attr isKindOf: XpfTextBackgroundColor]) color.

	Collection compile: source classified: ref category.
	md := (Collection compiledMethodAt: #do:) methodReference asMethodDefinition.
	
	snapshotBin := MCMczWriter new serializeInBinary: (MCSnapshot fromDefinitions: {md}).
	md2 := (DataStream on: ((RWBinaryOrTextStream with: snapshotBin) reset; yourself)) next definitions first.

	self
		should: md2 source isString;
		should: md2 sourceText isText;
		should: md source = md2 source;
		should: ((md2 sourceText attributesAt: 1) anySatisfy: [:attr |
				(attr isKindOf: XpfTextBackgroundColor) and: [attr color = color]]).
			
	"Clean up"
	Collection compile: source asString classified: ref category.! !

!XpfCtMonticelloTest methodsFor: 'as yet unclassified' stamp: 'mt 4/20/2009 16:17'!
testDefinitionFromReference

	| ref cm md |
	ref := MethodReference class: Collection selector: #do:.
	cm := Collection compiledMethodAt: #do:.
	md := ref asMethodDefinition.
	
	self
		should: cm getSource = ref sourceCode;
		should: ref sourceCode isText;
		should: ref source isString;
		should: md source isString;
		should: md sourceText isText.! !

!Text methodsFor: '*xpf-codetalk' stamp: 'mt 4/22/2009 19:16'!
removeAttributeOfKind: attClass from: start to: stop

	"Removes an attribute kind over the interval start to stop."
	runs := runs
		copyReplaceFrom: start
		to: stop
		with: ((runs copyFrom: start to: stop)	mapValues:
			[:attributes | attributes reject: [:each | each isKindOf: attClass]])! !

PanelMorph subclass: #XpfCtCodeChatMorph
	instanceVariableNames: 'model chatLog textEntry addMessageButton closeButton'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-CodeTalk-Morphs'!

!XpfCtCodeChatMorph class methodsFor: 'constants' stamp: 'mt 4/30/2009 08:23'!
defaultExtent

	^ 200@150! !

!XpfCtCodeChatMorph class methodsFor: 'instance creation' stamp: 'mt 4/29/2009 22:10'!
forAttribute: anXpfAttribute

	| instance |
	instance := self new.
	instance model attribute: anXpfAttribute.
	^ instance! !

!XpfCtCodeChatMorph methodsFor: 'accessing' stamp: 'mt 4/29/2009 22:42'!
addMessageButton

	addMessageButton ifNil: [addMessageButton := UITheme current
		newButtonIn: self
		for: self textEntry
		getState: nil
		action: #accept
		arguments: nil
		getEnabled: nil
		label: 'Add'
		help: ''].
	^ addMessageButton! !

!XpfCtCodeChatMorph methodsFor: 'accessing' stamp: 'mt 4/30/2009 09:37'!
chatLog

	chatLog ifNil: [chatLog := (UITheme current
		newMorphListIn: self
		for: self model
		list: #messages
		getSelected: nil
		setSelected: nil
		getEnabled: nil
		help: 'Let''s talk about code...')
		hResizing: #rigid;
		vResizing: #rigid;
		cellInset: 0;
		layoutInset: 0;
		borderWidth: 0;
		fillStyle: Color transparent;
		extent: self class defaultExtent.
		chatLog listMorph cellInset: 0].
	^ chatLog! !

!XpfCtCodeChatMorph methodsFor: 'accessing' stamp: 'mt 4/30/2009 08:18'!
closeButton

	closeButton ifNil: [closeButton := UITheme current
		newButtonIn: self
		for: self
		getState: nil
		action: #delete
		arguments: nil
		getEnabled: nil
		label: 'X'
		help: ''].
	^ closeButton! !

!XpfCtCodeChatMorph methodsFor: 'as yet unclassified' stamp: 'mt 4/30/2009 09:38'!
initialize

	super initialize.
	self
		"extent: self class defaultExtent;"
		hResizing: #shrinkWrap;
		vResizing: #shrinkWrap;
		listDirection: #topToBottom;
		borderWidth: 1;
		borderColor: Color black;
		changeTableLayout;
		fillStyle: (Color yellow alpha: 0.5);
		layoutInset: 5;
		cellInset: 5;
		useRoundedCorners;
		addMorphBack: self chatLog;
		addMorphBack: (UITheme current newRowIn: self for: {
			self textEntry.
			self addMessageButton.
			self closeButton}).! !

!XpfCtCodeChatMorph methodsFor: 'accessing' stamp: 'mt 4/29/2009 22:10'!
model

	model ifNil: [model := XpfCtCodeChatModel new].
	^ model! !

!XpfCtCodeChatMorph methodsFor: 'accessing' stamp: 'mt 4/29/2009 22:41'!
textEntry

	textEntry ifNil: [textEntry := UITheme current
		newTextEntryIn: self
		for: self model
		get: nil
		set: #addMessage:
		class: String
		getEnabled: nil
		help: ''].
	^ textEntry! !

PanelMorph subclass: #XpfCtMessageMorph
	instanceVariableNames: 'timestamp author message'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-CodeTalk-Morphs'!

!XpfCtMessageMorph class methodsFor: 'instance creation' stamp: 'mt 4/30/2009 09:04'!
timestamp: aTimeStamp author: aString message: messageString

	^ self new
		author: aString;
		timestamp: aTimeStamp;
		message: messageString! !

!XpfCtMessageMorph methodsFor: 'accessing' stamp: 'mt 4/30/2009 09:03'!
author

	author ifNil: [author := ''].
	^ author! !

!XpfCtMessageMorph methodsFor: 'accessing' stamp: 'mt 4/30/2009 09:04'!
author: aString

	author := aString! !

!XpfCtMessageMorph methodsFor: 'initialization' stamp: 'mt 4/30/2009 09:39'!
initialize

	super initialize.
	self
		changeTableLayout;
		hResizing: #spaceFill;
		vResizing: #shrinkWrap;
		listDirection: #topToBottom;
		borderWidth: 0;
		layoutInset: 4;
		cellInset: 0;
		fillStyle: Color white;
		initializeUserInterface.! !

!XpfCtMessageMorph methodsFor: 'initialization' stamp: 'mt 4/30/2009 09:04'!
initializeUserInterface

	self
		addMorphBack: self timestamp;
		addMorphBack: self message.! !

!XpfCtMessageMorph methodsFor: 'accessing' stamp: 'mt 4/30/2009 09:31'!
message

	message ifNil: [message := TextMorph new
		hResizing: #spaceFill;
		vResizing: #rigid;
		lock].
	^ message! !

!XpfCtMessageMorph methodsFor: 'accessing' stamp: 'mt 4/30/2009 09:35'!
message: aString

	self message contentsWrapped: aString asText.
	self message font: (XpfClient sansFontAt: 10).! !

!XpfCtMessageMorph methodsFor: 'accessing' stamp: 'mt 4/30/2009 09:24'!
timestamp

	timestamp ifNil: [timestamp := TextMorph new
		hResizing: #spaceFill;
		vResizing: #rigid;
		lock].
	^ timestamp! !

!XpfCtMessageMorph methodsFor: 'accessing' stamp: 'mt 4/30/2009 09:35'!
timestamp: aTimeStamp

	| text |
	text := '{1} - {2}:' format: {aTimeStamp printRelativeTimeStamp. self author}.
	self timestamp contents: text.
	self timestamp font: (XpfClient sansFontAt: 8).
	! !

Object subclass: #XpfCodeTalk
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-CodeTalk-Core'!

!XpfCodeTalk class methodsFor: 'as yet unclassified' stamp: 'mt 4/29/2009 08:32'!
initialize

	super initialize.
	MCMethodDefinition addInstVarName: #sourceText.
	Preferences addBooleanPreference: 'Show line numbers' category: #CodeTalk default: false balloonHelp: 'Enables line numbers in front of each codeline.'.
	Preferences addBooleanPreference: 'Show protocol for message' category: #CodeTalk default: false balloonHelp: 'Displays the protocol name after each message name in the code browser.'.! !

Object subclass: #XpfCtCodeChatModel
	instanceVariableNames: 'attribute'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-CodeTalk-Models'!

!XpfCtCodeChatModel methodsFor: 'adding' stamp: 'mt 4/29/2009 22:44'!
addMessage: aMessage

	self attribute ifNil: [^ self].
	self attribute addChatLine: aMessage.
	self changed: #messages.! !

!XpfCtCodeChatModel methodsFor: 'accessing' stamp: 'mt 4/29/2009 22:22'!
attribute

	^ attribute! !

!XpfCtCodeChatModel methodsFor: 'accessing' stamp: 'mt 4/29/2009 22:22'!
attribute: anXpfComplexAttribute

	attribute := anXpfComplexAttribute.
	self changed: #messages.! !

!XpfCtCodeChatModel methodsFor: 'accessing' stamp: 'mt 4/29/2009 22:21'!
messages

	self attribute ifNil: [^ #()].
	
	^ self attribute chat collect: [:line | XpfCtMessageMorph
		timestamp: (line at: #timestamp)
		author: (line at: #author)
		message: (line at: #message)]! !

OBTextMorphEditorWithShout subclass: #XpfEditor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-CodeTalk-Core'!

!XpfEditor class methodsFor: 'as yet unclassified' stamp: 'mt 2/5/2009 17:36'!
initializeCmdKeyShortcuts
	super initializeCmdKeyShortcuts.
	CmdActions
		at: ($q asInteger + 1) put: #markAsGood:;
		at: ($r asInteger + 1) put: #markAsBad:;
		at: ($t asInteger + 1) put: #markAsUnclear:;
		at: ($w asInteger + 1) put: #removeMarkup:.
	
! !

!XpfEditor methodsFor: 'as yet unclassified' stamp: 'mt 4/26/2009 19:10'!
changeParagraph: aParagraph
	"Add a back reference to the textmorph to the paragraph."

	super changeParagraph: aParagraph.
	(aParagraph isKindOf: XpfParagraph) & (morph isKindOf: XpfTextMorph)
		ifTrue: [aParagraph textMorph: morph. morph removeAllMorphs].! !

!XpfEditor methodsFor: 'as yet unclassified' stamp: 'mt 4/26/2009 19:17'!
markAsBad: aCharacterStream
	paragraph setBackgroundForSelectionWith: Color red.
	self userHasEdited.
	^ true! !

!XpfEditor methodsFor: 'as yet unclassified' stamp: 'mt 1/23/2009 14:44'!
markAsGood: aCharacterStream
	paragraph setBackgroundForSelectionWith: Color green.
	self userHasEdited.
	^ true
	
! !

!XpfEditor methodsFor: 'as yet unclassified' stamp: 'mfp 2/3/2009 16:17'!
markAsUnclear: aCharacterStream
	paragraph setBackgroundForSelectionWith: Color lightGray.
	self userHasEdited.
	^ true
	
! !

!XpfEditor methodsFor: 'as yet unclassified' stamp: 'mt 2/5/2009 17:36'!
removeMarkup: aCharacterStream
	paragraph removeBackgroundForSelection.
	self userHasEdited.
	^ true

	
! !

SHTextStylerST80 subclass: #XpfTextStyler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-CodeTalk-Core'!

!XpfTextStyler methodsFor: 'private' stamp: 'mt 4/29/2009 23:01'!
privateStyle: aText
	"First, backup current style information about background color in text runs. Then let Shout work. Then restore background color information for text runs."

	| backupRuns |
	backupRuns := aText runs.

	super privateStyle: aText.
	
	backupRuns withStartStopAndValueDo: [:start :stop :attrs | |a|
		a := attrs detect: [:attr | attr isKindOf: XpfComplexAttribute] ifNone: [nil].
		a ifNotNil: [aText addAttribute: a from: start to: stop].
	]! !

!XpfTextStyler methodsFor: 'as yet unclassified' stamp: 'mt 4/29/2009 23:02'!
unstyledTextFrom: aText

	| backupRuns result |
	backupRuns := aText runs.

	result := super unstyledTextFrom: aText.
	
	backupRuns withStartStopAndValueDo: [:start :stop :attrs | |a|
		a := attrs detect: [:attr | attr isKindOf: XpfComplexAttribute] ifNone: [nil].
		a ifNotNil: [result addAttribute: a from: start to: stop]].
	^ result! !

!OBMethodNode methodsFor: '*xpf-codetalk' stamp: 'mt 4/26/2009 21:50'!
categoryText

	^ (' ({1})' format: {self category}) asText addAttribute: (TextColor color: Color gray)! !

!OBCodeBrowser methodsFor: '*xpf-codetalk-commands' stamp: 'topa 2/13/2009 13:41'!
cmdMarkAsBad
	^ XpfMarkBadCommand! !

!OBCodeBrowser methodsFor: '*xpf-codetalk-commands' stamp: 'topa 2/13/2009 13:41'!
cmdMarkAsGood
	^ XpfMarkGoodCommand! !

!OBCodeBrowser methodsFor: '*xpf-codetalk-commands' stamp: 'topa 2/13/2009 13:41'!
cmdMarkAsUnclear
	^ XpfMarkUnclearCommand! !

!OBCodeBrowser methodsFor: '*xpf-codetalk-commands' stamp: 'topa 2/13/2009 13:43'!
cmdRemoveMarkup
	^ XpfRemoveMarkupCommand! !

!OBPluggableListMorph methodsFor: '*xpf-codetalk-override' stamp: 'mt 4/26/2009 21:32'!
listMorphClass
    ^XpfLazyListMorph! !

ImageMorph subclass: #XpfCtChatIconMorph
	instanceVariableNames: 'attribute'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-CodeTalk-Core'!

!XpfCtChatIconMorph methodsFor: 'accessing' stamp: 'mt 4/29/2009 23:03'!
attribute
	^ attribute! !

!XpfCtChatIconMorph methodsFor: 'accessing' stamp: 'mt 4/29/2009 23:03'!
attribute: anObject
	attribute := anObject! !

!XpfCtChatIconMorph methodsFor: 'as yet unclassified' stamp: 'mt 4/29/2009 22:54'!
handlesMouseDown: evt

	^ true! !

!XpfCtChatIconMorph methodsFor: 'initialization' stamp: 'mt 4/29/2009 22:54'!
initialize

	super initialize.
	self image: (MenuIcons noteIcon).! !

!XpfCtChatIconMorph methodsFor: 'as yet unclassified' stamp: 'mt 4/30/2009 08:17'!
mouseDown: evt

	self attribute ifNil: [^ self].
	self owner addMorph: ((XpfCtCodeChatMorph forAttribute: self attribute)
		position: self position).! !

!OBPluggableTextMorphWithShout class methodsFor: '*xpf-codetalk' stamp: 'mt 1/26/2009 14:54'!
on: anObject text: getTextSel accept: setTextSel readSelection: getSelectionSel menu: getMenuSel
	|styler answer stylerClass |
	answer := self new.
	stylerClass := answer stylerClass.
	styler := stylerClass
		ifNotNil:[
			stylerClass new
				view: answer;
				yourself].
	^ answer
		styler: styler;
		on: anObject
		text: getTextSel
		accept: setTextSel
		readSelection: getSelectionSel
		menu: getMenuSel! !

!OBPluggableTextMorphWithShout methodsFor: '*xpf-codetalk' stamp: 'topa 2/13/2009 13:48'!
stylerClass
	^XpfTextStyler! !

!OBPluggableTextMorphWithShout methodsFor: '*xpf-codetalk-override' stamp: 'topa 2/13/2009 13:48'!
textMorphClass
	"Answer the class used to create the receiver's textMorph"
	^XpfTextMorph! !

OBTextMorphWithShout subclass: #XpfTextMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-CodeTalk-Core'!

!XpfTextMorph methodsFor: 'private' stamp: 'topa 2/13/2009 14:09'!
editorClass
	"Answer the class used to create the receiver's editor"
	
	^XpfEditor! !

!XpfTextMorph methodsFor: 'as yet unclassified' stamp: 'mt 4/29/2009 21:35'!
initialize

	super initialize.
	
	(Preferences preferenceAt: #showLineNumbers ifAbsent: [Preference new rawValue: false]) preferenceValue
		ifTrue: [self leftMargin: (Preferences standardCodeFont widthOfString: '99') * 1.7].! !

!XpfTextMorph methodsFor: 'as yet unclassified' stamp: 'mt 4/29/2009 15:52'!
leftMargin: aNumber

	self margins: (aNumber@0 corner: 0@0).! !

!XpfTextMorph methodsFor: 'private' stamp: 'mt 4/22/2009 20:24'!
paragraphClass
	
	^ XpfParagraph! !

!MenuIcons class methodsFor: '*xpf-codetalk' stamp: 'mt 2/5/2009 18:08'!
markBadIcon
	^ Icons
			at: #'markBad'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self markBadIconContents readStream) ].! !

!MenuIcons class methodsFor: '*xpf-codetalk' stamp: 'mt 2/5/2009 18:06'!
markBadIconContents
	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAABGdBTUEAAK/INwWK6QAAABl0
RVh0U29mdHdhcmUAQWRvYmUgSW1hZ2VSZWFkeXHJZTwAAACxSURBVDjL7dItC8JQAIXh491H
WbDvD1pEDIIKm1zDxqKi0WIULAZFYc1msF3ErEZlMC9Mhxx/gTAR28KpDxx4QRK/DCXwAbDg
0oLMTShtQF0F5AlwvwHkqy+Zxxs+lwsmvs8DKrIw8DCh8njNLOxRtxrU4yF3MFRhIBFQ2XxG
3W7yXq8xjULGsIsDFwF58zzq0YBpFPDc6XIKp/iFI4S7h5BbWGoFW03gyABVtyzxT8Ab8Xze
i+tkcykAAAAASUVORK5CYII='! !

!MenuIcons class methodsFor: '*xpf-codetalk' stamp: 'mt 2/5/2009 18:08'!
markGoodIcon
	^ Icons
			at: #'markGood'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self markGoodIconContents readStream) ].! !

!MenuIcons class methodsFor: '*xpf-codetalk' stamp: 'mt 2/5/2009 18:06'!
markGoodIconContents
	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAABGdBTUEAAK/INwWK6QAAABl0
RVh0U29mdHdhcmUAQWRvYmUgSW1hZ2VSZWFkeXHJZTwAAAC5SURBVDjLY/j//z8DJZhh1ADs
BjjsspIC4gb77ZZX7TdbXLVda9Zgs8xEihQDGmZfm/7/0KOD/3ff3/V/6plJ/y3mGjYQbYD9
NsurBx4e+D/10tT/nWc6/i+5sui/+RS9q0QbYLfB/OrWO1v+d5/p+t96qvn/3Auz/pt0aRNv
gPVyk4appyf+X3xl4f/ZF2b+n3Co579+mSrxXrCcZyhlMV2/wbRP56pRq+ZV3SLlBq1EOanR
lEgjAwAXIuIDq5qm/AAAAABJRU5ErkJggg=='! !

!MenuIcons class methodsFor: '*xpf-codetalk' stamp: 'mt 2/5/2009 18:08'!
markUnknownIcon
	^ Icons
			at: #'markUnknown'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self markUnknownIconContents readStream) ].! !

!MenuIcons class methodsFor: '*xpf-codetalk' stamp: 'mt 2/5/2009 18:07'!
markUnknownIconContents
	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAQAAAC1+jfqAAAABGdBTUEAAK/INwWK6QAAABl0
RVh0U29mdHdhcmUAQWRvYmUgSW1hZ2VSZWFkeXHJZTwAAABlSURBVCjPY/jPgB8yDC4FilKK
DfJXZa6KNwhKYVfQkPW/63/b/+T/XA1YFchd7fqf/j/2f+N/5qtYFUhe7fif9D/sf91/BuwK
hBoS/jcBpcP/M2C3gluKrYHhKhA2MEgN2pDEDgEb0f5zlvXgVgAAAABJRU5ErkJggg=='! !

!MenuIcons class methodsFor: '*xpf-codetalk' stamp: 'mt 2/5/2009 18:08'!
removeMarkupIcon
	^ Icons
			at: #'removeMarkup'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self removeMarkupIconContents readStream) ].! !

!MenuIcons class methodsFor: '*xpf-codetalk' stamp: 'mt 2/5/2009 18:07'!
removeMarkupIconContents
	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAQAAAC1+jfqAAAABGdBTUEAAK/INwWK6QAAABl0
RVh0U29mdHdhcmUAQWRvYmUgSW1hZ2VSZWFkeXHJZTwAAABbSURBVCjPzdAxDoAgEERRzsFp
95JbGI2ASA2SCOX3Ahtr8tuXTDIO959bCxRfpOitWS5vA+lMJg9JbKCTTmMQ1QS3ThqVQbBB
lsbgpXLYE8lHCXrqLptf9km7Dzv+FwGTaznIAAAAAElFTkSuQmCC'! !

!RunArray class methodsFor: '*xpf-codetalk-override' stamp: 'mt 4/22/2009 19:15'!
scanFrom: strm
	"Read the style section of a fileOut or sources file.  nextChunk has already been done.  We need to return a RunArray of TextAttributes of various kinds.  These are written by the implementors of writeScanOn:"
	| rr vv aa this |
	(strm peekFor: $( ) ifFalse: [^ nil].
	rr := OrderedCollection new.
	[strm skipSeparators.
	 strm peekFor: $)] whileFalse: 
		[rr add: (Number readFrom: strm)].
	vv := OrderedCollection new.	"Value array"
	aa := OrderedCollection new.	"Attributes list"
	[(this := strm next) == nil] whileFalse: [
		this == $, ifTrue: [vv add: aa asArray.  aa := OrderedCollection new].
		this == $a ifTrue: [aa add: 
			(TextAlignment new alignment: (Integer readFrom: strm))].
		this == $f ifTrue: [aa add: 
			(TextFontChange new fontNumber: (Integer readFrom: strm))].
		this == $F ifTrue: [aa add: (TextFontReference toFont: 
			(StrikeFont familyName: (strm upTo: $#) size: (Integer readFrom: strm)))].
		this == $b ifTrue: [aa add: (TextEmphasis bold)].
		this == $i ifTrue: [aa add: (TextEmphasis italic)].
		this == $u ifTrue: [aa add: (TextEmphasis underlined)].
		this == $= ifTrue: [aa add: (TextEmphasis struckOut)].
		this == $n ifTrue: [aa add: (TextEmphasis normal)].
		this == $- ifTrue: [aa add: (TextKern kern: -1)].
		this == $+ ifTrue: [aa add: (TextKern kern: 1)].
		this == $c ifTrue: [aa add: (TextColor scanFrom: strm)]. "color"
		this == $h ifTrue: [aa add: (XpfTextBackgroundColor scanFrom: strm)]. "background color - CodeTalk"
		this == $L ifTrue: [aa add: (TextLink scanFrom: strm)].	"L not look like 1"
		this == $R ifTrue: [aa add: (TextURL scanFrom: strm)].
				"R capitalized so it can follow a number"
		this == $q ifTrue: [aa add: (TextSqkPageLink scanFrom: strm)].
		this == $p ifTrue: [aa add: (TextSqkProjectLink scanFrom: strm)].
		this == $P ifTrue: [aa add: (TextPrintIt scanFrom: strm)].
		this == $d ifTrue: [aa add: (TextDoIt scanFrom: strm)].
		"space, cr do nothing"
		].
	aa size > 0 ifTrue: [vv add: aa asArray].
	^ self runs: rr asArray values: vv asArray
"
RunArray scanFrom: (ReadStream on: '(14 50 312)f1,f1b,f1LInteger +;i')
"! !

!MCMethodDefinition class methodsFor: '*xpf-codetalk-override' stamp: 'mt 4/20/2009 15:56'!
forMethodReference: aMethodReference
	"CodeTalk: Get the markup from the method reference and put it into the definition."

	| definition |
	definition := self cachedDefinitions at: aMethodReference compiledMethod ifAbsent: [].
	(definition isNil
		or: [definition selector ~= aMethodReference methodSymbol]
		or: [definition className ~= aMethodReference classSymbol]
		or: [definition classIsMeta ~= aMethodReference classIsMeta]
		or: [definition category ~= aMethodReference category])
			ifTrue: [definition := (self 
						className: aMethodReference classSymbol
						classIsMeta: aMethodReference classIsMeta
						selector: aMethodReference methodSymbol
						category: aMethodReference category
						timeStamp: aMethodReference timeStamp
						source: aMethodReference source)
						sourceText: aMethodReference sourceCode.
					self cachedDefinitions at: aMethodReference compiledMethod put: definition].
	^ definition
	! !

!MCMethodDefinition methodsFor: '*xpf-codetalk-override' stamp: 'cs 4/17/2009 18:23'!
addMethodAdditionTo: aCollection
	| methodAddition |
	methodAddition := MethodAddition new
		compile: self sourceText
		classified: category
		withStamp: timeStamp
		notifying: (SyntaxError new category: category)
		logSource: true
		inClass: self actualClass.
	"This might raise an exception and never return"
	methodAddition createCompiledMethod.
	aCollection add: methodAddition.
! !

!MCMethodDefinition methodsFor: '*xpf-codetalk-override' stamp: 'cs 4/17/2009 18:24'!
load
	self actualClass
		compile: self sourceText
		classified: category
		withStamp: timeStamp
		notifying: (SyntaxError new category: category)! !

!MCMethodDefinition methodsFor: '*xpf-codetalk' stamp: 'cs 4/20/2009 16:16'!
sourceText

	^ sourceText ifNil: [self source asText]! !

!MCMethodDefinition methodsFor: '*xpf-codetalk' stamp: 'mt 3/24/2009 15:52'!
sourceText: aText

	sourceText := aText.! !

MultiNewParagraph subclass: #XpfParagraph
	instanceVariableNames: 'textMorph showLineNumbers'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-CodeTalk-Core'!

!XpfParagraph methodsFor: 'displaying' stamp: 'mt 4/29/2009 21:35'!
displayOn: aCanvas using: displayScanner at: somePosition
	"Draw background color then selection and text (super)."

	| line fontWidth |
	self updateProperties.

	(self lineIndexForPoint: aCanvas clipRect topLeft)
		to: (self lineIndexForPoint: aCanvas clipRect bottomRight)
		do: [ :i | line := lines at: i.
				self drawBackgroundOn: aCanvas at: i.
				showLineNumbers ifTrue: [
					self textMorph ifNotNilDo: [ :t | self
						drawLineNumber: (i < 10 ifTrue: [' '] ifFalse: ['']), i asString
						on: aCanvas
						at: (t position x @ (line top + 2)).
						fontWidth := Preferences standardCodeFont widthOfString: '99'.
						aCanvas
							line: (t position x + fontWidth + 3) @ line top
							to: (t position x + fontWidth + 3) @ line bottom
							width: 1
							color: Color gray]]].
		
	super displayOn: aCanvas using: displayScanner at: somePosition.! !

!XpfParagraph methodsFor: 'displaying' stamp: 'mt 4/29/2009 22:57'!
drawBackgroundOn: aCanvas at: index 

	| cb1 cb2 textLine bgAttr line |
	line := lines at: index.
	textLine := self text 
		copyFrom: line first
		to: line last.
	textLine runs withStartStopAndValueDo: 
		[ :start :stop :attributes | 
		bgAttr := attributes 
			detect: [ :each | each isMemberOf: XpfComplexAttribute ]
			ifNone: [  ].
		bgAttr ifNotNil: 
			[ cb1 := self characterBlockForIndex: start + (line first - 1).
			cb2 := self characterBlockForIndex: stop + (line first - 1).
			"Highlight the attribute."
			aCanvas 
				fillRectangle: (cb1 left @ line top corner: cb2 right @ line bottom)
				color: bgAttr color.
			"Highlight beginning of the line (schould be inside the textMorph margin)."
			"aCanvas
				fillRectangle: ((self textMorph position x + 20) @ line top corner: (self textMorph position x + 23) @ line bottom)
				color: (bgAttr color copy alpha: 1.0)."
			"Show the morph of the attribute."
			(selectionStart = selectionStop and: [selectionStart textLine = line])
				ifFalse: [(self textMorph submorphs includes: bgAttr morph)
					ifTrue: [self textMorph removeMorph: bgAttr morph]]
				ifTrue: [
					(textLine runs size < (stop + 1)
						or: [(textLine attributesAt: stop + 1)
							noneSatisfy: [:att | att isKindOf: XpfComplexAttribute]])
						ifTrue: [
							(self textMorph submorphs includes: bgAttr morph)
								ifFalse: [self textMorph addMorph: bgAttr morph].
							bgAttr morph position: cb2 right @ (line top - bgAttr morph height)]]]].! !

!XpfParagraph methodsFor: 'displaying' stamp: 'mt 4/29/2009 21:31'!
drawLineNumber: aString on: aCanvas at: aPoint

	aCanvas
		drawString: aString
		from: 1
		to: aString size
		at: aPoint
		font: Preferences standardCodeFont
		color: Color gray.! !

!XpfParagraph methodsFor: 'displaying' stamp: 'mt 4/29/2009 22:57'!
removeBackgroundForSelection

	selectionStart stringIndex == selectionStop ifTrue: [^nil].
	self text removeAttributeOfKind: XpfComplexAttribute from: selectionStart stringIndex to: selectionStop stringIndex - 1.! !

!XpfParagraph methodsFor: 'displaying' stamp: 'mt 4/29/2009 22:57'!
setBackgroundForSelectionWith: aColor

	selectionStart stringIndex == selectionStop ifTrue: [^nil].
	self text
		addAttribute: (XpfComplexAttribute color: aColor)
		from: selectionStart stringIndex
		to: selectionStop stringIndex - 1.! !

!XpfParagraph methodsFor: 'accessing' stamp: 'mt 4/22/2009 20:37'!
textMorph
	^ textMorph! !

!XpfParagraph methodsFor: 'accessing' stamp: 'mt 4/22/2009 20:37'!
textMorph: anObject
	textMorph := anObject! !

!XpfParagraph methodsFor: 'accessing' stamp: 'mt 4/29/2009 13:22'!
updateProperties

	showLineNumbers ifNil: [showLineNumbers := (Preferences preferenceAt: #showLineNumbers ifAbsent: [Preference new rawValue: false]) preferenceValue].! !

OBCommand subclass: #XpfCodeMarkCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-CodeTalk-Commands'!

!XpfCodeMarkCommand class methodsFor: 'testing' stamp: 'cs 1/27/2009 17:30'!
takesText
	^ true! !

!XpfCodeMarkCommand methodsFor: 'as yet unclassified' stamp: 'mfp 2/3/2009 16:13'!
execute
	"'inspired' by ORCmdPrettyPrint>>execute"
	| panel morph editor |
	
	panel := requestor browser panels 
		detect: [ :each | each isKindOf: OBDefinitionPanel ]
		ifNone: [ ^ self ].
	morph := OBPluggableTextMorph allSubInstances
		detect: [ :each | each model == panel ]
		ifNone: [ ^ self ].
	editor := morph textMorph editor.
	self mark: target in: editor.
	morph hasUnacceptedEdits: true! !

!XpfCodeMarkCommand methodsFor: 'accessing' stamp: 'cs 1/27/2009 17:31'!
group
	^ #general! !

!XpfCodeMarkCommand methodsFor: 'testing' stamp: 'cs 1/27/2009 17:31'!
isActive
	^ target isKindOf: OBTextSelection! !

!XpfCodeMarkCommand methodsFor: 'as yet unclassified' stamp: 'mfp 2/3/2009 16:14'!
mark: aTarget in: anEditor
	^ self subclassResponsibility! !

XpfCodeMarkCommand subclass: #XpfMarkBadCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-CodeTalk-Commands'!

!XpfMarkBadCommand methodsFor: 'accessing' stamp: 'mt 2/5/2009 18:09'!
icon
	^#markBadIcon! !

!XpfMarkBadCommand methodsFor: 'accessing' stamp: 'mfp 2/3/2009 16:12'!
keystroke
	^ $B! !

!XpfMarkBadCommand methodsFor: 'accessing' stamp: 'mfp 2/3/2009 16:11'!
label
	^ 'mark bad'! !

!XpfMarkBadCommand methodsFor: 'editor-bridge' stamp: 'mfp 2/3/2009 16:15'!
mark: aTarget in: anEditor
	anEditor markAsBad: aTarget.! !

XpfCodeMarkCommand subclass: #XpfMarkGoodCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-CodeTalk-Commands'!

!XpfMarkGoodCommand methodsFor: 'accessing' stamp: 'cs 3/18/2009 15:27'!
icon

	^ #markGoodIcon! !

!XpfMarkGoodCommand methodsFor: 'accessing' stamp: 'mfp 2/3/2009 16:20'!
keystroke
	^ $G! !

!XpfMarkGoodCommand methodsFor: 'accessing' stamp: 'mfp 2/3/2009 16:20'!
label
	^ 'mark good'! !

!XpfMarkGoodCommand methodsFor: 'editor-bridge' stamp: 'mfp 2/3/2009 16:20'!
mark: aTarget in: anEditor
	anEditor markAsGood: aTarget.! !

XpfCodeMarkCommand subclass: #XpfMarkUnclearCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-CodeTalk-Commands'!

!XpfMarkUnclearCommand methodsFor: 'accessing' stamp: 'cs 3/18/2009 15:27'!
icon

	^ #markUnknownIcon! !

!XpfMarkUnclearCommand methodsFor: 'accessing' stamp: 'mfp 2/3/2009 16:24'!
keystroke
	^ $U! !

!XpfMarkUnclearCommand methodsFor: 'accessing' stamp: 'mfp 2/3/2009 16:24'!
label
	^ 'mark unclear'! !

!XpfMarkUnclearCommand methodsFor: 'editor-bridge' stamp: 'mfp 2/3/2009 16:25'!
mark: aTarget in: anEditor
	anEditor markAsUnclear: aTarget.! !

XpfCodeMarkCommand subclass: #XpfRemoveMarkupCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-CodeTalk-Commands'!

!XpfRemoveMarkupCommand methodsFor: 'as yet unclassified' stamp: 'cs 3/18/2009 15:27'!
icon

	^ #removeMarkupIcon! !

!XpfRemoveMarkupCommand methodsFor: 'as yet unclassified' stamp: 'mt 2/5/2009 17:46'!
label
	^'remove markup'! !

!XpfRemoveMarkupCommand methodsFor: 'as yet unclassified' stamp: 'mt 2/5/2009 17:44'!
mark: aTarget in: anEditor
	anEditor removeMarkup: aTarget.! !

TextAttribute subclass: #XpfCtAttribute
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-CodeTalk-Core'!

XpfCtAttribute subclass: #XpfComplexAttribute
	instanceVariableNames: 'color chat morph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-CodeTalk-Core'!

!XpfComplexAttribute class methodsFor: 'instance creation' stamp: 'mt 4/29/2009 22:55'!
color: aColor

	^ self new color: aColor! !

!XpfComplexAttribute class methodsFor: 'instance creation' stamp: 'mt 4/29/2009 23:08'!
scanFrom: strm

	Transcript show: 'blubb'; cr.
	^ self new! !

!XpfComplexAttribute methodsFor: 'accessing' stamp: 'mt 4/29/2009 21:59'!
addChatLine: aString

	self chat add: (Dictionary newFrom: {
		#author -> Utilities authorInitials.
		#timestamp -> TimeStamp now.
		#message -> aString}).! !

!XpfComplexAttribute methodsFor: 'accessing' stamp: 'mt 4/29/2009 21:51'!
chat

	chat ifNil: [chat := OrderedCollection new].
	^ chat! !

!XpfComplexAttribute methodsFor: 'accessing' stamp: 'mt 4/29/2009 21:50'!
color

	^ color! !

!XpfComplexAttribute methodsFor: 'accessing' stamp: 'mt 4/29/2009 21:50'!
color: aColor
	
	color := aColor copy alpha: 0.4.! !

!XpfComplexAttribute methodsFor: 'accessing' stamp: 'mt 4/29/2009 23:03'!
morph

	morph ifNil: [morph := XpfCtChatIconMorph new attribute: self].
	^ morph! !

!XpfCtAttribute methodsFor: 'as yet unclassified' stamp: 'mt 4/29/2009 21:45'!
= other

	^ (other class == self class)! !

!XpfCtAttribute methodsFor: 'html' stamp: 'mt 4/29/2009 21:46'!
closeHtmlOn: aStream 
	"put on the given stream the tag to close the html  
	representation of the receiver"
	aStream nextPutAll: '</span>'! !

!XpfCtAttribute methodsFor: 'scanning' stamp: 'mt 4/29/2009 21:46'!
dominates: other
	^ other class == self class! !

!XpfCtAttribute methodsFor: 'html' stamp: 'mt 4/29/2009 21:47'!
openHtmlOn: aStream 
	"put on the given stream the tag to open the html  
	representation of the receiver"
	aStream nextPutAll: '<span>'! !

!XpfCtAttribute methodsFor: 'scanning' stamp: 'mt 4/30/2009 09:36'!
writeScanOn: strm
! !

XpfCtAttribute subclass: #XpfTextBackgroundColor
	instanceVariableNames: 'color morph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-CodeTalk-Core'!

!XpfTextBackgroundColor class methodsFor: 'instance creation' stamp: 'mt 1/26/2009 09:31'!
color: aColor
	^ self new color: aColor! !

!XpfTextBackgroundColor class methodsFor: 'instance creation' stamp: 'mt 1/26/2009 09:42'!
scanFrom: strm
	"read a color in the funny format used by Text styles on files. c125000255 or cblue;"

	| r g b |
	strm peek isDigit
		ifTrue:
			[r := (strm next: 3) asNumber.
			g := (strm next: 3) asNumber.
			b := (strm next: 3) asNumber.
			^ self color: (Color r: r g: g b: b range: 255)].
	"A name of a color"
	^ self color: (Color perform: (strm upTo: $;) asSymbol)! !

!XpfTextBackgroundColor methodsFor: 'comparing' stamp: 'mt 4/29/2009 21:45'!
= other 

	^ super = other and: [other color = color]! !

!XpfTextBackgroundColor methodsFor: 'accessing' stamp: 'mt 1/22/2009 11:22'!
color
	^ color! !

!XpfTextBackgroundColor methodsFor: 'accessing' stamp: 'mt 1/22/2009 17:51'!
color: aColor
	color := aColor copy alpha: 0.4.! !

!XpfTextBackgroundColor methodsFor: 'comparing' stamp: 'mt 1/22/2009 11:23'!
hash
	^ color hash! !

!XpfTextBackgroundColor methodsFor: 'accessing' stamp: 'mt 4/26/2009 19:01'!
morph

	morph ifNil: [morph := MenuIcons noteIcon asMorph].
	^ morph! !

!XpfTextBackgroundColor methodsFor: 'html' stamp: 'mt 1/22/2009 11:25'!
openHtmlOn: aStream 
	"put on the given stream the tag to open the html  
	representation of the receiver"
	aStream nextPutAll: '<span style="background-color: #' , color printHtmlString , '">'! !

!XpfTextBackgroundColor methodsFor: 'printing' stamp: 'mt 1/22/2009 11:25'!
printOn: aStream
	super printOn: aStream.
	aStream nextPutAll: ' code: '; print: color! !

!XpfTextBackgroundColor methodsFor: 'scanning' stamp: 'mt 1/22/2009 11:27'!
writeScanOn: strm
	"Two formats.  c125000255 or cblue;"

	| nn str |
	strm nextPut: $h. "h ... highlight"
	(nn := color name) ifNotNil: [
		(self class respondsTo: nn) ifTrue: [
			^ strm nextPutAll: nn; nextPut: $;]].
	(Array with: color red with: color green with: color blue) do: [:float |
		str := '000', (float * 255) asInteger printString.
		strm nextPutAll: (str copyFrom: str size-2 to: str size)]! !
XpfCodeTalk initialize!
